# Class VulkanDescriptorBufferInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanDescriptorBufferInfo.Builder

Enclosing class:
  `VulkanDescriptorBufferInfo`

public static final class VulkanDescriptorBufferInfo.Builder extends Object
Builds instances of type `VulkanDescriptorBufferInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanDescriptorBufferInfo`
  `build()`
  Builds a new `VulkanDescriptorBufferInfo`.
  `final VulkanDescriptorBufferInfo.Builder`
  `from(VulkanDescriptorBufferInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanDescriptorBufferInfoType` instance.
  `final VulkanDescriptorBufferInfo.Builder`
  `setBuffer(VulkanBufferType buffer)`
  Initializes the value for the `buffer` attribute.
  `final VulkanDescriptorBufferInfo.Builder`
  `setOffset(long offset)`
  Initializes the value for the `offset` attribute.
  `final VulkanDescriptorBufferInfo.Builder`
  `setRange(long range)`
  Initializes the value for the `range` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanDescriptorBufferInfo.Builder from(VulkanDescriptorBufferInfoType instance)
    Fill a builder with attribute values from the provided `VulkanDescriptorBufferInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setBuffer

    public final VulkanDescriptorBufferInfo.Builder setBuffer(VulkanBufferType buffer)
    Initializes the value for the `buffer` attribute.
    Parameters:
      `buffer` - The value for buffer
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VulkanDescriptorBufferInfo.Builder setOffset(long offset)
    Initializes the value for the `offset` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `offset`.

    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### setRange

    public final VulkanDescriptorBufferInfo.Builder setRange(long range)
    Initializes the value for the `range` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `range`.

    Parameters:
      `range` - The value for range
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanDescriptorBufferInfo build()
    Builds a new `VulkanDescriptorBufferInfo`.
    Returns:
      An immutable instance of VulkanDescriptorBufferInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing